from __future__ import annotations

from collections.abc import Mapping
from typing import Any, TypeVar

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

T = TypeVar("T", bound="LegacytypesWorkLog")


@_attrs_define
class LegacytypesWorkLog:
    """
    Attributes:
        field_id (str | Unset):
        ended_at (str | Unset):
        notes (str | Unset):
        started_at (str | Unset):
        time_spent (int | Unset):
        user (str | Unset):
    """

    field_id: str | Unset = UNSET
    ended_at: str | Unset = UNSET
    notes: str | Unset = UNSET
    started_at: str | Unset = UNSET
    time_spent: int | Unset = UNSET
    user: str | Unset = UNSET
    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        field_id = self.field_id

        ended_at = self.ended_at

        notes = self.notes

        started_at = self.started_at

        time_spent = self.time_spent

        user = self.user

        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if field_id is not UNSET:
            field_dict["_id"] = field_id
        if ended_at is not UNSET:
            field_dict["ended_at"] = ended_at
        if notes is not UNSET:
            field_dict["notes"] = notes
        if started_at is not UNSET:
            field_dict["started_at"] = started_at
        if time_spent is not UNSET:
            field_dict["time_spent"] = time_spent
        if user is not UNSET:
            field_dict["user"] = user

        return field_dict

    @classmethod
    def from_dict(cls: type[T], src_dict: Mapping[str, Any]) -> T:
        d = dict(src_dict)
        field_id = d.pop("_id", UNSET)

        ended_at = d.pop("ended_at", UNSET)

        notes = d.pop("notes", UNSET)

        started_at = d.pop("started_at", UNSET)

        time_spent = d.pop("time_spent", UNSET)

        user = d.pop("user", UNSET)

        legacytypes_work_log = cls(
            field_id=field_id,
            ended_at=ended_at,
            notes=notes,
            started_at=started_at,
            time_spent=time_spent,
            user=user,
        )

        legacytypes_work_log.additional_properties = d
        return legacytypes_work_log

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
